    	LIST    p=12F675, r=dec,  c=200
	errorlevel -302, -305
#include <p12F675.inc>
	__CONFIG  _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _INTRC_OSC_NOCLKOUT & _MCLRE_OFF & _CPD_OFF

	cblock	0x20
	bitctr			; bit counter for RS232
	btime			; for bit time & half bit time delays
	endc

	org	H'2100' 	; Initialize EEPROM Data

	de 0, "(c) Phil Green, Phil_G on most RC forums. Kitbug bit 7 dropper, 300bd  "
	de 0, "Note Kitbug sends inverted TTL, static=low "

	org 0
	banksel	0x80		; select Register Page 1
	call	3FFh
	movwf	OSCCAL		; calibrate osc
	clrf	ANSEL 		; all digital I/O
	movlw	b'00001010'
	movwf	TRISIO		; Make GP1 input, rest outputs, (GPIO3 is always input)
	banksel	0		; back to Register Page 0
	movlw	07h		; 
	movwf	CMCON 		; switch comparator off
	clrf	ADCON0		; switch adc off
	bcf	GPIO, 0		; inv TTL serial out, static=low

rxser   btfss   GPIO, 1		; wait for hi (inverted TTL start bit)
        goto	rxser

 	movlw	.208		; wait half a bit time
	movwf	btime		
sbitdly	nop			; 1
	nop			; 1
	nop			; 1
	nop			; 1
	nop			; 1
	decfsz	btime		; 1
	goto	sbitdly		; 2   = 8       8 x 208 = 1664uS   half-bit time

	btfss   GPIO, 1		; check still in start bit
	goto    rxser		; try again if not
	bsf	GPIO, 0		; echo start bit
	movlw   0x07		; read only 7 bits, then set 8th high (inv ttl serial)
	movwf   bitctr

nxtrcv 	call	bittime
	btfss   GPIO, 1		; 
	bcf	GPIO,0		; echo this bit to rs232 out
	btfsc   GPIO, 1		; (inv ttl serial)
	bsf	GPIO,0
	decfsz  bitctr,F	; copy 7 bits 
	goto    nxtrcv		; then...
	call	bittime
	bsf	GPIO,0		; set bit 8 bit high (inverted ttl serial)
	call	bittime
	bcf	GPIO,0		; set bit 8 bit low (inverted ttl serial)
	call	bittime
	goto	rxser

bittime	goto	$+1		; 2    btime is already zero from previous loop
	goto	$+1		; 2
	goto	$+1		; 2
	goto	$+1		; 2
	goto	$+1		; 2
	decfsz	btime		; 1
	goto	bittime		; 2   = 13       13 x 256 = 3328uS   bit time
	return

	end



        